#ifndef FILTER_HAMMING_WINDOW_H
#define FILTER_HAMMING_WINDOW_H

#include <cstddef>
#include <vector>
#include <filter/window/window.hpp>

namespace Filter {
class HammingWindow : public IWindow {
 private:
  std::vector<float> window;

 public:
  HammingWindow(std::size_t width);

  ~HammingWindow() override {}

  void Dump(const std::string& path) const override;
  const std::vector<float>& getWindow() const override { return window; }
};
} // namespace Filter

#endif