#ifndef RECORDER_CONFIG_H
#define RECORDER_CONFIG_H

#include <stdbool.h>
#include <stdint.h>

#include <libps2000/ps2000.h>

typedef struct {
  uint32_t buffersize;
  uint32_t max_buffersize;
  uint32_t sample_interval;
  PS2000_RANGE range;
  PS2000_TIME_UNITS time_units;
  bool iq_mode;
  bool dc_mode;
} config;

PS2000_RANGE parse_range(char* range);
PS2000_TIME_UNITS parse_units(char* unit);

config* get_config(int argc, char** argv);

#endif