#include <fstream>
#include <vector>

#include <filter/filter/filter.hpp>

#include <iostream>

namespace Filter {
IFilter::IFilter(std::size_t size) : impulseResponse(size) {}

void IFilter::Dump(const std::string& path) const {
  std::ofstream output;
  output.open(path, std::ios::out | std::ios::binary);
  output.write(reinterpret_cast<const char*>(impulseResponse.data()), sizeof(float) * impulseResponse.size());
  output.close();
}

void IFilter::ConvolveIQ(const std::vector<float>& input, std::vector<float>& output) {
  // TODO: SIMD

  output.clear();

  auto itIn = input.begin();
  auto itOut = output.begin();

  while (itIn != input.end()) {
    float I = 0, Q = 0;
    for (float h : impulseResponse) {
      // I
      I += *itIn * h;

      // Q
      Q += *itIn * h;
    }

    *(itOut + 0) = I;
    *(itOut + 1) = Q;

    itIn += 2;
    itOut += 2;
  }
}
} // namespace Filter