#include <cmath>
#include <cstdio>
#include <fstream>
#include <numbers>

#include <filter/window/hamming_window.hpp>

namespace Filter {
HammingWindow::HammingWindow(std::size_t width) : window(width) {
  for (std::size_t i = 0; i < width; i++) {
    window[i] = (25 / 46.0f) - (21 / 46.0f) * std::cos(2.0f * std::numbers::pi * i / (float)width);
  }
}

void HammingWindow::Dump(const std::string& path) const {
  std::ofstream output;
  output.open(path, std::ios::out | std::ios::binary);
  output.write(reinterpret_cast<const char*>(getWindow().data()), sizeof(float) * getWindow().size());
  output.close();
}
} // namespace Filter